diff --git a/content/media/gstreamer/media_player_gstreamer.h b/content/media/gstreamer/media_player_gstreamer.h
new file mode 100644
index 0000000..82e866b
--- /dev/null
+++ b/content/media/gstreamer/media_player_gstreamer.h
@@ -0,0 +1,190 @@
+// Copyright 2015 The Chromium Authors. All rights reserved.
+// Use of this source code is governed by a BSD-style license that can be
+// found in the LICENSE file.
+
+#ifndef CONTENT_MEDIA_GSTREAMER_MEDIAPLAYER_GSTREAMER_H_
+#define CONTENT_MEDIA_GSTREAMER_MEDIAPLAYER_GSTREAMER_H_
+
+#include <condition_variable>
+#include <mutex>
+#include <string>
+#include <vector>
+
+#include "base/basictypes.h"
+#include "base/containers/hash_tables.h"
+#include "base/memory/ref_counted.h"
+#include "base/memory/scoped_ptr.h"
+#include "base/memory/weak_ptr.h"
+#include "base/threading/thread_checker.h"
+#include "base/time/default_tick_clock.h"
+#include "base/time/time.h"
+#include "content/common/media/media_channel_filter.h"
+#include "content/media/gstreamer/gst_chromium_http_source.h"
+#include "content/renderer/media/render_media_log.h"
+#include "media/base/time_delta_interpolator.h"
+#include "media/blink/buffered_data_source.h"
+#include "media/blink/buffered_data_source_host_impl.h"
+#include "third_party/WebKit/public/web/WebLocalFrame.h"
+#include "third_party/WebKit/public/web/WebFrameClient.h"
+#include "ui/gfx/geometry/rect_f.h"
+
+#include <gst/player/gstplayer.h>
+
+struct _GstGLContext;
+struct _GstGLDisplay;
+typedef struct _GstGLContext GstGLContext;
+typedef struct _GstGLDisplay GstGLDisplay;
+
+namespace cc {
+class ContextProvider;
+}
+
+namespace media {
+class MediaLog;
+}
+
+namespace content {
+
+struct RunHolder;
+class MediaPlayerGStreamer;
+class MediaChannel;
+class ResourceDispatcher;
+class GStreamerBufferedDataSourceFactory;
+
+class MediaPlayerGStreamerFactory {
+ public:
+  MediaPlayerGStreamerFactory(
+      media::MediaLog* media_log,
+      content::ResourceDispatcher* resource_dispatcher,
+      scoped_refptr<base::SingleThreadTaskRunner> main_task_runner,
+      scoped_refptr<base::SingleThreadTaskRunner> gl_task_runner);
+
+  ~MediaPlayerGStreamerFactory();
+
+  MediaPlayerGStreamer* create(int player_id,
+                               content::MediaChannel* media_channel);
+
+ private:
+  scoped_refptr<media::MediaLog> media_log_;
+  ResourceDispatcher* resource_dispatcher_;
+  scoped_refptr<base::SingleThreadTaskRunner> main_task_runner_;
+  scoped_refptr<base::SingleThreadTaskRunner> gl_task_runner_;
+};
+
+// TODO: use ubercompositor and inherits from cc::VideoFrameProvider.
+class MediaPlayerGStreamer {
+ public:
+  MediaPlayerGStreamer(
+      int player_id,
+      const GURL& url,
+      content::MediaChannel* media_channel,
+      media::MediaLog* media_log,
+      content::ResourceDispatcher* resource_dispatcher,
+      scoped_refptr<base::SingleThreadTaskRunner> main_task_runner,
+      scoped_refptr<base::SingleThreadTaskRunner> gl_task_runner);
+
+  virtual ~MediaPlayerGStreamer();
+
+  void Load(GURL url, unsigned position_update_interval_ms);
+  void Play();
+  void Pause();
+  void Seek(const base::TimeDelta& duration);
+  void ReleaseTexture(unsigned texture_id);
+  void AddSourceId(const std::string& source_id,
+                   const std::string& type,
+                   const std::vector<std::string>& codecs);
+  void RemoveSourceId(const std::string& source_id);
+  void SetDuration(const base::TimeDelta& duration);
+  void MarkEndOfStream();
+  void UnmarkEndOfStream();
+  void SetSequenceMode(const std::string& source_id, bool sequence_mode);
+  void AppendData(const std::string& source_id,
+                  const std::vector<unsigned char>& data,
+                  const std::vector<base::TimeDelta>& times);
+  void Abort(const std::string& source_id);
+  void SetGroupStartTimestampIfInSequenceMode(
+      const std::string& source_id,
+      const base::TimeDelta& timestamp_offset);
+  void RemoveSegment(const std::string& source_id,
+                     const base::TimeDelta& start,
+                     const base::TimeDelta& end);
+  void AddKey(const std::string& session_id,
+              const std::string& key_id,
+              const std::string& key);
+
+  void DidLoad();
+  void OnDurationChanged(const base::TimeDelta& duration);
+  void OnVideoSizeChanged(int width, int height);
+  void OnMediaInfoUpdated(GstPlayerMediaInfo* info);
+  void DidPlay();
+  void DidPause();
+  void DidSeek(const base::TimeDelta& delta);
+  void DidEOS();
+  void DidStop();
+  void InitSegmentReceived(const std::string& source_id);
+  void BufferedRangeUpdate(const std::string& source_id,
+                           const std::vector<base::TimeDelta>& ranges);
+  void OnPositionUpdated(base::TimeDelta position);
+  void OnBufferingUpdated(int percent);
+  void OnError(int error);
+  void OnSeekDone(GstClockTime position);
+
+  void DoReleaseTexture(unsigned texture_id);
+
+  GstGLContext* GstgldisplayCreateContextCallback(GstGLDisplay* display,
+                                                  GstGLContext* other_context);
+  bool GlimagesinkDrawCallback(GstElement* sink,
+                               GstGLContext* context,
+                               GstSample* sample);
+  void GstSourceSetup(GstElement* playbin, GstElement* src);
+  void SyncMessage(GstBus* bus, GstMessage* msg);
+  void AsyncMessage(GstBus* bus, GstMessage* msg);
+
+ private:
+  void SetupContextProvider();
+  void SetupGLContext();
+  void CleanupSamples();
+  void CleanupGLContext();
+  void ExecuteInGLThread(RunHolder* holder);
+
+  void DataSourceInitialized(bool success);
+  void NotifyDownloading(bool is_downloading);
+
+  const int player_id_;
+
+  GURL url_;
+
+  scoped_refptr<cc::ContextProvider> provider_;
+
+  content::MediaChannel* media_channel_;
+
+  scoped_refptr<media::MediaLog> media_log_;
+  media::BufferedDataSourceHostImpl buffered_data_source_host_;
+
+  blink::WebLocalFrame* web_frame_;
+
+  ResourceDispatcher* resource_dispatcher_;
+
+  scoped_refptr<base::SingleThreadTaskRunner> main_task_runner_;
+  scoped_refptr<base::SingleThreadTaskRunner> gl_task_runner_;
+
+  GstPlayer* player_;
+  GstElement* media_source_;
+  GstGLDisplay* gst_gl_display_;
+  GstGLContext* gst_gl_context_;
+
+  std::mutex gl_thread_mutex_;
+  std::condition_variable gl_thread_condition_;
+
+  GstClockTime seek_time_;
+
+  typedef base::hash_map<unsigned, GstSample*> GstSampleMap;
+  GstSampleMap samples_;
+  bool was_preroll_;
+
+  base::WeakPtrFactory<MediaPlayerGStreamer> weak_factory_;
+};
+
+}  // namespace content
+
+#endif  // CONTENT_MEDIA_GSTREAMER_MEDIAPLAYER_GSTREAMER_H_
diff --git a/content/media/in_process_media_thread.cc b/content/media/in_process_media_thread.cc
new file mode 100644
index 0000000..40af8fa
--- /dev/null
+++ b/content/media/in_process_media_thread.cc
@@ -0,0 +1,39 @@
+// Copyright 2015 The Chromium Authors. All rights reserved.
+// Use of this source code is governed by a BSD-style license that can be
+// found in the LICENSE file.
+
+#include "content/media/in_process_media_thread.h"
+
+#include "content/media/media_child_thread.h"
+#include "content/media/media_process.h"
+
+namespace content {
+
+InProcessMediaThread::InProcessMediaThread(
+    const InProcessChildThreadParams& params)
+    : base::Thread("Chrome_InProcMediaThread"),
+      params_(params),
+      media_process_(NULL) {}
+
+InProcessMediaThread::~InProcessMediaThread() {
+  Stop();
+}
+
+void InProcessMediaThread::Init() {
+  media_process_ = new MediaProcess();
+  // The process object takes ownership of the thread object, so do not
+  // save and delete the pointer.
+  media_process_->set_main_thread(new MediaChildThread(params_));
+}
+
+void InProcessMediaThread::CleanUp() {
+  SetThreadWasQuitProperly(true);
+  delete media_process_;
+}
+
+base::Thread* CreateInProcessMediaThread(
+    const InProcessChildThreadParams& params) {
+  return new InProcessMediaThread(params);
+}
+
+}  // namespace content
diff --git a/content/media/in_process_media_thread.h b/content/media/in_process_media_thread.h
new file mode 100644
index 0000000..14ed352
--- /dev/null
+++ b/content/media/in_process_media_thread.h
@@ -0,0 +1,42 @@
+// Copyright 2015 The Chromium Authors. All rights reserved.
+// Use of this source code is governed by a BSD-style license that can be
+// found in the LICENSE file.
+
+#ifndef CONTENT_MEDIA_IN_PROCESS_MEDIA_THREAD_H_
+#define CONTENT_MEDIA_IN_PROCESS_MEDIA_THREAD_H_
+
+#include "base/threading/thread.h"
+#include "content/common/content_export.h"
+#include "content/common/content_export.h"
+#include "content/common/in_process_child_thread_params.h"
+
+namespace content {
+
+class MediaProcess;
+
+// This class creates a media thread (instead of a media process), when running
+// with --in-process-media or --single-process.
+class InProcessMediaThread : public base::Thread {
+ public:
+  InProcessMediaThread(const InProcessChildThreadParams& params);
+  ~InProcessMediaThread() override;
+
+ protected:
+  void Init() override;
+  void CleanUp() override;
+
+ private:
+  InProcessChildThreadParams params_;
+
+  // Deleted in CleanUp() on the media thread, so don't use smart pointers.
+  MediaProcess* media_process_;
+
+  DISALLOW_COPY_AND_ASSIGN(InProcessMediaThread);
+};
+
+CONTENT_EXPORT base::Thread* CreateInProcessMediaThread(
+    const InProcessChildThreadParams& params);
+
+}  // namespace content
+
+#endif  // CONTENT_MEDIA_IN_PROCESS_MEDIA_THREAD_H_
diff --git a/content/media/media_child_thread.cc b/content/media/media_child_thread.cc
new file mode 100644
index 0000000..6539e10
--- /dev/null
+++ b/content/media/media_child_thread.cc
@@ -0,0 +1,330 @@
+// Copyright (c) 2015 The Chromium Authors. All rights reserved.
+// Use of this source code is governed by a BSD-style license that can be
+// found in the LICENSE file.
+
+#include "content/media/media_child_thread.h"
+
+#include <thread>
+
+#include "base/bind.h"
+#include "base/debug/stack_trace.h"
+#include "base/lazy_instance.h"
+#include "base/message_loop/message_pump_glib.h"
+#include "base/threading/simple_thread.h"
+#include "base/threading/thread_local.h"
+#include "base/threading/thread_restrictions.h"
+#include "base/threading/worker_pool.h"
+#include "build/build_config.h"
+#include "content/child/child_gpu_memory_buffer_manager.h"
+#include "content/child/child_process.h"
+#include "content/child/thread_safe_sender.h"
+#include "content/common/gpu/client/context_provider_command_buffer.h"
+#include "content/common/gpu/client/gpu_channel_host.h"
+#include "content/common/gpu/gpu_messages.h"
+#include "content/common/gpu/gpu_process_launch_causes.h"
+#include "content/common/media/media_messages.h"
+#include "content/media/gstreamer/media_player_gstreamer.h"
+#include "content/public/common/content_client.h"
+#include "content/public/common/content_switches.h"
+#include "gin/public/debug.h"
+#include "gpu/GLES2/gl2extchromium.h"
+#include "gpu/command_buffer/common/gles2_cmd_utils.h"
+#include "ipc/ipc_channel_handle.h"
+#include "ipc/ipc_sync_message_filter.h"
+#include "media/base/audio_hardware_config.h"
+#include "media/base/media.h"
+#include "public/web/WebKit.h"
+
+using base::ThreadRestrictions;
+
+namespace content {
+namespace {
+
+blink::WebGraphicsContext3D::Attributes GetOffscreenAttribs() {
+  blink::WebGraphicsContext3D::Attributes attributes;
+  attributes.shareResources = true;
+  attributes.depth = false;
+  attributes.stencil = false;
+  attributes.antialias = false;
+  attributes.noAutomaticFlushes = true;
+  return attributes;
+}
+
+static base::LazyInstance<scoped_refptr<ThreadSafeSender>>
+    g_thread_safe_sender = LAZY_INSTANCE_INITIALIZER;
+
+bool MediaProcessLogMessageHandler(int severity,
+                                   const char* file,
+                                   int line,
+                                   size_t message_start,
+                                   const std::string& str) {
+  std::string header = str.substr(0, message_start);
+  std::string message = str.substr(message_start);
+
+  g_thread_safe_sender.Get()->Send(
+      new MediaHostMsg_OnLogMessage(severity, header, message));
+
+  return false;
+}
+
+ChildThreadImpl::Options GetOptions() {
+  ChildThreadImpl::Options::Builder builder;
+
+  return builder.Build();
+}
+
+}  // namespace
+
+MediaChildThread::MediaChildThread(bool dead_on_arrival,
+                                   const DeferredMessages& deferred_messages)
+    : ChildThreadImpl(GetOptions()),
+      dead_on_arrival_(dead_on_arrival),
+      deferred_messages_(deferred_messages),
+      in_browser_process_(false),
+      blink_platform_(new content::BlinkPlatformImpl) {
+  g_thread_safe_sender.Get() = thread_safe_sender();
+  blink::initializeWithoutV8(blink_platform_.get());
+}
+
+MediaChildThread::MediaChildThread(const InProcessChildThreadParams& params)
+    : ChildThreadImpl(ChildThreadImpl::Options::Builder()
+                          .InBrowserProcess(params)
+                          .Build()),
+      dead_on_arrival_(false),
+      in_browser_process_(true),
+      blink_platform_(nullptr) {
+  DCHECK(base::CommandLine::ForCurrentProcess()->HasSwitch(
+             switches::kSingleProcess) ||
+         base::CommandLine::ForCurrentProcess()->HasSwitch(
+             switches::kInProcessMedia));
+  g_thread_safe_sender.Get() = thread_safe_sender();
+}
+
+MediaChildThread::~MediaChildThread()
+{
+  if (blink_platform_)
+      blink::shutdownWithoutV8();
+}
+
+void MediaChildThread::Shutdown() {
+  ChildThreadImpl::Shutdown();
+  logging::SetLogMessageHandler(NULL);
+
+  gl_thread_.reset();
+
+  if (gpu_channel_.get())
+    gpu_channel_->DestroyChannel();
+}
+
+void MediaChildThread::Init(const base::Time& process_start_time) {
+  process_start_time_ = process_start_time;
+}
+
+bool MediaChildThread::Send(IPC::Message* msg) {
+  // The media process must never send a synchronous IPC message to the browser
+  // process. This could result in deadlock.
+  DCHECK(!msg->is_sync() || msg->type() == GpuHostMsg_EstablishGpuChannel::ID);
+  return ChildThreadImpl::Send(msg);
+}
+
+bool MediaChildThread::OnControlMessageReceived(const IPC::Message& msg) {
+  // Call from the main thread, not the io thread.
+
+  bool handled = true;
+  IPC_BEGIN_MESSAGE_MAP(MediaChildThread, msg)
+    IPC_MESSAGE_HANDLER(MediaMsg_Initialize, OnInitialize)
+    IPC_MESSAGE_HANDLER(MediaMsg_Clean, OnClean)
+    IPC_MESSAGE_HANDLER(MediaMsg_Crash, OnCrash)
+    IPC_MESSAGE_HANDLER(MediaMsg_Hang, OnHang)
+    IPC_MESSAGE_UNHANDLED(handled = false)
+  IPC_END_MESSAGE_MAP()
+
+  if (handled)
+    return true;
+
+  return media_channel_filter_.get() &&
+         media_channel_filter_->OnMessageReceived(msg);
+}
+
+scoped_refptr<cc::ContextProvider>
+MediaChildThread::CreateSharedContextProvider() {
+  // Created in the main thread but likely to be bind in another thread.
+  DCHECK(IsMainThread());
+
+  if (!provider_.get() || provider_->DestroyedOnMainThread()) {
+    provider_ = NULL;
+
+    if (!provider_.get()) {
+      if (!gpu_channel_.get())
+        EstablishGpuChannelSync(
+            CAUSE_FOR_GPU_LAUNCH_MEDIA_GSTREAMER_CONTEXT_INITIALIZE);
+
+      provider_ = ContextProviderCommandBuffer::Create(
+          CreateOffscreenContext3d(), MEDIA_GSTREAMER_CONTEXT);
+    }
+  }
+
+  return provider_;
+}
+
+GpuChannelHost* MediaChildThread::EstablishGpuChannelSync(
+    CauseForGpuLaunch cause_for_gpu_launch) {
+  TRACE_EVENT0("media", "MediaChildThread::EstablishGpuChannelSync");
+
+  if (gpu_channel_.get()) {
+    // Do nothing if we already have a GPU channel or are already
+    // establishing one.
+    if (!gpu_channel_->IsLost())
+      return gpu_channel_.get();
+
+    // Recreate the channel if it has been lost.
+    gpu_channel_->DestroyChannel();
+    gpu_channel_ = NULL;
+  }
+
+  // Ask the browser for the channel name.
+  int client_id = 0;
+  IPC::ChannelHandle channel_handle;
+  gpu::GPUInfo gpu_info;
+  if (!Send(new GpuHostMsg_EstablishGpuChannel(cause_for_gpu_launch, &client_id,
+                                               &channel_handle, &gpu_info)) ||
+#if defined(OS_POSIX)
+      channel_handle.socket.fd == -1 ||
+#endif
+      channel_handle.name.empty()) {
+    // Otherwise cancel the connection.
+    return NULL;
+  }
+
+  GetContentClient()->SetGpuInfo(gpu_info);
+
+  io_thread_task_runner_ = ChildProcess::current()->io_task_runner();
+
+  gpu_channel_ = GpuChannelHost::Create(
+      this, gpu_info, channel_handle,
+      ChildProcess::current()->GetShutDownEvent(), gpu_memory_buffer_manager());
+  return gpu_channel_.get();
+}
+
+scoped_ptr<WebGraphicsContext3DCommandBufferImpl>
+MediaChildThread::CreateOffscreenContext3d() {
+  blink::WebGraphicsContext3D::Attributes attributes(GetOffscreenAttribs());
+  bool lose_context_when_out_of_memory = true;
+  return make_scoped_ptr(
+      WebGraphicsContext3DCommandBufferImpl::CreateOffscreenContext(
+          gpu_channel_.get(), attributes, lose_context_when_out_of_memory,
+          GURL("chrome://gpu/MediaChildThread::CreateOffscreenContext3d"),
+          WebGraphicsContext3DCommandBufferImpl::SharedMemoryLimits(), NULL));
+}
+
+bool MediaChildThread::IsMainThread() {
+  return !!current();
+}
+
+scoped_refptr<base::SingleThreadTaskRunner>
+MediaChildThread::GetIOThreadTaskRunner() {
+  return io_thread_task_runner_;
+}
+
+scoped_ptr<base::SharedMemory> MediaChildThread::AllocateSharedMemory(
+    size_t size) {
+  return scoped_ptr<base::SharedMemory>(
+      ChildThreadImpl::AllocateSharedMemory(size, thread_safe_sender()));
+}
+
+CreateCommandBufferResult MediaChildThread::CreateViewCommandBuffer(
+    int32 surface_id,
+    const GPUCreateCommandBufferConfig& init_params,
+    int32 route_id) {
+  TRACE_EVENT1("media", "MediaChildThread::CreateViewCommandBuffer",
+               "surface_id", surface_id);
+
+  CreateCommandBufferResult result = CREATE_COMMAND_BUFFER_FAILED;
+  IPC::Message* message = new GpuHostMsg_CreateViewCommandBuffer(
+      surface_id, init_params, route_id, &result);
+
+  // Allow calling this from the compositor thread.
+  thread_safe_sender()->Send(message);
+
+  return result;
+}
+
+class MessagePumpGlibLocal : public base::MessagePumpGlib {
+ public:
+  explicit MessagePumpGlibLocal(GMainContext* context) : context_(context) {}
+  ~MessagePumpGlibLocal() override {
+    g_main_context_pop_thread_default(context_);
+  }
+
+ private:
+  GMainContext* context_;
+};
+
+static scoped_ptr<base::MessagePump> CreateMessagePumpGlibLocal() {
+  GMainContext* context = g_main_context_new();
+  g_main_context_push_thread_default(context);
+  return scoped_ptr<base::MessagePump>(new MessagePumpGlibLocal(context));
+}
+
+void MediaChildThread::OnInitialize() {
+  DCHECK_NE(ChildProcess::current()->io_task_runner(),
+            base::ThreadTaskRunnerHandle::Get().get());
+  VLOG(1) << "Media: Initializing";
+
+  Send(new MediaHostMsg_Initialized(!dead_on_arrival_));
+  while (!deferred_messages_.empty()) {
+    Send(deferred_messages_.front());
+    deferred_messages_.pop();
+  }
+
+  if (dead_on_arrival_) {
+    LOG(ERROR) << "Exiting media process due to errors during initialization";
+    base::MessageLoop::current()->Quit();
+    return;
+  }
+
+  // We don't need to pipe log messages if we are running the GPU thread in
+  // the browser process.
+  if (!in_browser_process_)
+    logging::SetLogMessageHandler(MediaProcessLogMessageHandler);
+
+  gl_thread_.reset(new base::Thread("GLThread"));
+  base::Thread::Options options;
+  options.message_pump_factory = base::Bind(&CreateMessagePumpGlibLocal);
+
+  gl_thread_->StartWithOptions(options);
+  gl_task_runner_ = gl_thread_->task_runner();
+
+  scoped_refptr<media::MediaLog> media_log(
+      new media::MediaLog());  // TODO: new RenderMediaLog
+
+  GStreamerBufferedDataSourceFactory::Init(media_log.get(), resource_dispatcher(),
+      base::ThreadTaskRunnerHandle::Get());
+
+  media_channel_filter_ = new MediaChannelFilter(
+      GetRouter(), ChildProcess::current()->io_task_runner(),
+      ChildProcess::current()->GetShutDownEvent(), channel(),
+      new MediaPlayerGStreamerFactory(media_log.get(), resource_dispatcher(),
+                                      base::ThreadTaskRunnerHandle::Get(),
+                                      gl_task_runner_));
+}
+
+void MediaChildThread::OnClean() {
+  VLOG(1) << "Media: Cleaning all resources";
+}
+
+void MediaChildThread::OnCrash() {
+  VLOG(1) << "Media: Simulating media process crash";
+  // Good bye, cruel world.
+  volatile int* it_s_the_end_of_the_world_as_we_know_it = NULL;
+  *it_s_the_end_of_the_world_as_we_know_it = 0xdead;
+}
+
+void MediaChildThread::OnHang() {
+  VLOG(1) << "Media: Simulating media process hang";
+  for (;;) {
+    // TODO: Implement media process watchdog?
+  }
+}
+
+}  // namespace content
diff --git a/content/media/media_child_thread.h b/content/media/media_child_thread.h
new file mode 100644
index 0000000..9b5bb00
--- /dev/null
+++ b/content/media/media_child_thread.h
@@ -0,0 +1,137 @@
+// Copyright (c) 2015 The Chromium Authors. All rights reserved.
+// Use of this source code is governed by a BSD-style license that can be
+// found in the LICENSE file.
+
+#ifndef CONTENT_MEDIA_MEDIA_CHILD_THREAD_H_
+#define CONTENT_MEDIA_MEDIA_CHILD_THREAD_H_
+
+#include <queue>
+#include <string>
+
+#include "base/basictypes.h"
+#include "base/command_line.h"
+#include "base/memory/ref_counted.h"
+#include "base/memory/scoped_ptr.h"
+#include "base/time/time.h"
+#include "build/build_config.h"
+#include "content/child/blink_platform_impl.h"
+#include "content/child/child_thread_impl.h"
+#include "content/common/gpu/client/gpu_channel_host.h"
+#include "content/common/gpu/gpu_result_codes.h"
+#include "content/common/media/media_channel.h"
+#include "content/common/media/media_channel_filter.h"
+#include "content/common/media/media_config.h"
+
+namespace blink {
+class WebGraphicsContext3D;
+}
+
+namespace base {
+class MessageLoopProxy;
+class Thread;
+}
+
+namespace cc {
+class ContextProvider;
+}
+
+namespace cc_blink {
+class ContextProviderWebContext;
+}
+
+namespace sandbox {
+class TargetServices;
+}
+
+namespace content {
+
+class CompositorForwardingMessageFilter;
+class ContextProviderCommandBuffer;
+class GpuChannelHost;
+class MediaPlayerGStreamer;
+class WebGraphicsContext3DCommandBufferImpl;
+
+// The main thread of the media process. There will only ever be one of
+// these per process. It does process initialization and shutdown,
+// sends commands to the media.
+class MediaChildThread : public ChildThreadImpl, public GpuChannelHostFactory {
+ public:
+  typedef std::queue<IPC::Message*> DeferredMessages;
+
+  explicit MediaChildThread(bool dead_on_arrival,
+                            const DeferredMessages& deferred_messages);
+
+  explicit MediaChildThread(const InProcessChildThreadParams& params);
+
+  ~MediaChildThread() override;
+
+  void Shutdown() override;
+
+  void Init(const base::Time& process_start_time);
+  void StopWatchdog();
+
+  // ChildThread overrides.
+  bool Send(IPC::Message* msg) override;
+  bool OnControlMessageReceived(const IPC::Message& msg) override;
+
+  scoped_refptr<cc::ContextProvider> CreateSharedContextProvider();
+
+ private:
+  // GpuChannelHostFactory implementation:
+  bool IsMainThread() override;
+  scoped_refptr<base::SingleThreadTaskRunner> GetIOThreadTaskRunner() override;
+  scoped_ptr<base::SharedMemory> AllocateSharedMemory(size_t size) override;
+  CreateCommandBufferResult CreateViewCommandBuffer(
+      int32 surface_id,
+      const GPUCreateCommandBufferConfig& init_params,
+      int32 route_id) override;
+
+  // Synchronously establish a channel to the GPU plugin if not previously
+  // established or if it has been lost (for example if the GPU plugin crashed).
+  // If there is a pending asynchronous request, it will be completed by the
+  // time this routine returns.
+  GpuChannelHost* EstablishGpuChannelSync(CauseForGpuLaunch);
+
+  scoped_ptr<WebGraphicsContext3DCommandBufferImpl> CreateOffscreenContext3d();
+
+  // Message handlers.
+  void OnInitialize();
+
+  void OnClean();
+  void OnCrash();
+  void OnHang();
+
+  // Set this flag to true if a fatal error occurred before we receive the
+  // OnInitialize message, in which case we just declare ourselves DOA.
+  bool dead_on_arrival_;
+
+  // Error messages collected in media_main() before the thread is created.
+  DeferredMessages deferred_messages_;
+
+  // Whether the media thread is running in the browser process.
+  bool in_browser_process_;
+
+  base::Time process_start_time_;
+
+  scoped_refptr<MediaChannelFilter> media_channel_filter_;
+
+  // The channel from the media process to the GPU process.
+  scoped_refptr<GpuChannelHost> gpu_channel_;
+
+  // Cache of variables that are needed on the compositor thread by
+  // GpuChannelHostFactory methods.
+  scoped_refptr<base::SingleThreadTaskRunner> io_thread_task_runner_;
+
+  scoped_ptr<base::Thread> gl_thread_;
+  scoped_refptr<base::SingleThreadTaskRunner> gl_task_runner_;
+
+  scoped_refptr<cc::ContextProvider> provider_;
+
+  scoped_ptr<content::BlinkPlatformImpl> blink_platform_;
+
+  DISALLOW_COPY_AND_ASSIGN(MediaChildThread);
+};
+
+}  // namespace content
+
+#endif  // CONTENT_MEDIA_MEDIA_CHILD_THREAD_H_
diff --git a/content/media/media_main.cc b/content/media/media_main.cc
new file mode 100644
index 0000000..4c9159d
--- /dev/null
+++ b/content/media/media_main.cc
@@ -0,0 +1,167 @@
+// Copyright (c) 2015 The Chromium Authors. All rights reserved.
+// Use of this source code is governed by a BSD-style license that can be
+// found in the LICENSE file.
+
+#include <stdlib.h>
+
+#include "base/debug/stack_trace.h"
+#include "base/lazy_instance.h"
+#include "base/message_loop/message_loop.h"
+#include "base/metrics/histogram.h"
+#include "base/metrics/statistics_recorder.h"
+#include "base/rand_util.h"
+#include "base/strings/string_number_conversions.h"
+#include "base/strings/stringprintf.h"
+#include "base/third_party/dynamic_annotations/dynamic_annotations.h"
+#include "base/threading/platform_thread.h"
+#include "base/trace_event/trace_event.h"
+#include "build/build_config.h"
+#include "content/child/child_process.h"
+#include "content/common/content_constants_internal.h"
+#include "content/common/media/media_config.h"
+#include "content/common/media/media_messages.h"
+#include "content/common/sandbox_linux/sandbox_linux.h"
+#include "content/media/media_child_thread.h"
+#include "content/media/media_process.h"
+#include "content/public/common/content_client.h"
+#include "content/public/common/content_switches.h"
+#include "content/public/common/main_function_params.h"
+
+#if defined(USE_X11)
+#include "ui/base/x/x11_util.h"
+#endif
+
+#if defined(OS_LINUX)
+#include "content/public/common/sandbox_init.h"
+#endif
+
+#if defined(SANITIZER_COVERAGE)
+#include <sanitizer/common_interface_defs.h>
+#include <sanitizer/coverage_interface.h>
+#endif
+
+namespace content {
+
+namespace {
+
+bool WarmUpSandbox(const base::CommandLine& command_line);
+
+#if defined(OS_LINUX)
+bool StartSandboxLinux();
+#endif
+
+base::LazyInstance<MediaChildThread::DeferredMessages> deferred_messages =
+    LAZY_INSTANCE_INITIALIZER;
+
+bool MediaProcessLogMessageHandler(int severity,
+                                   const char* file,
+                                   int line,
+                                   size_t message_start,
+                                   const std::string& str) {
+  std::string header = str.substr(0, message_start);
+  std::string message = str.substr(message_start);
+  deferred_messages.Get().push(
+      new MediaHostMsg_OnLogMessage(severity, header, message));
+  return false;
+}
+
+}  // namespace anonymous
+
+// Main function for starting the media process.
+int MediaMain(const MainFunctionParams& parameters) {
+  // base::debug::EnableInProcessStackDumping();
+  base::debug::EnableInProcessStackDumpingForSandbox();
+
+  TRACE_EVENT0("media", "MediaMain");
+  base::trace_event::TraceLog::GetInstance()->SetProcessName("Media Process");
+  base::trace_event::TraceLog::GetInstance()->SetProcessSortIndex(
+      kTraceEventMediaProcessSortIndex);
+
+  const base::CommandLine& command_line = parameters.command_line;
+  if (command_line.HasSwitch(switches::kMediaStartupDialog)) {
+    ChildProcess::WaitForDebugger("Media");
+  }
+
+  base::Time start_time = base::Time::Now();
+
+  logging::SetLogMessageHandler(MediaProcessLogMessageHandler);
+#if defined(OS_LINUX)
+  base::MessageLoop main_message_loop(base::MessageLoop::TYPE_DEFAULT);
+#else
+  base::MessageLoop main_message_loop(base::MessageLoop::TYPE_IO);
+#endif
+
+  base::PlatformThread::SetName("CrMediaMain");
+
+  bool initialized_sandbox = true;
+
+  // Warm up resources
+  if (WarmUpSandbox(command_line)) {
+    initialized_sandbox = false;
+  }
+
+  if (!initialized_sandbox) {
+    StartSandboxLinux();
+  }
+
+  logging::SetLogMessageHandler(NULL);
+
+  MediaProcess media_process;
+
+  MediaChildThread* child_thread =
+      new MediaChildThread(false, deferred_messages.Get());
+  while (!deferred_messages.Get().empty())
+    deferred_messages.Get().pop();
+
+  child_thread->Init(start_time);
+
+  media_process.set_main_thread(child_thread);
+
+  {
+    TRACE_EVENT0("media", "Run Message Loop");
+    main_message_loop.Run();
+  }
+
+  return 0;
+}
+
+namespace {
+
+bool WarmUpSandbox(const base::CommandLine& command_line) {
+  {
+    TRACE_EVENT0("media", "Warm up rand");
+    // Warm up the random subsystem, which needs to be done pre-sandbox on all
+    // platforms.
+    (void)base::RandUint64();
+  }
+  return true;
+}
+
+#if defined(OS_LINUX)
+bool StartSandboxLinux() {
+  TRACE_EVENT0("media", "Initialize sandbox");
+
+  bool res = false;
+
+// TODO: WarmUpSandbox -- access hardware resources?
+
+#if defined(SANITIZER_COVERAGE)
+  const std::string sancov_file_name =
+      "media." + base::Uint64ToString(base::RandUint64());
+  LinuxSandbox* linux_sandbox = LinuxSandbox::GetInstance();
+  linux_sandbox->sanitizer_args()->coverage_sandboxed = 1;
+  linux_sandbox->sanitizer_args()->coverage_fd =
+      __sanitizer_maybe_open_cov_file(sancov_file_name.c_str());
+  linux_sandbox->sanitizer_args()->coverage_max_block_size = 0;
+#endif
+
+  // LinuxSandbox::InitializeSandbox() must always be called
+  // with only one thread.
+  res = LinuxSandbox::InitializeSandbox();
+  return res;
+}
+#endif  // defined(OS_LINUX)
+
+}  // namespace.
+
+}  // namespace content
diff --git a/content/media/media_process.cc b/content/media/media_process.cc
new file mode 100644
index 0000000..99e3891
--- /dev/null
+++ b/content/media/media_process.cc
@@ -0,0 +1,13 @@
+// Copyright (c) 2015 The Chromium Authors. All rights reserved.
+// Use of this source code is governed by a BSD-style license that can be
+// found in the LICENSE file.
+
+#include "content/media/media_process.h"
+
+namespace content {
+
+MediaProcess::MediaProcess() {}
+
+MediaProcess::~MediaProcess() {}
+
+}  // namespace content
diff --git a/content/media/media_process.h b/content/media/media_process.h
new file mode 100644
index 0000000..98dcc37
--- /dev/null
+++ b/content/media/media_process.h
@@ -0,0 +1,22 @@
+// Copyright (c) 2015 The Chromium Authors. All rights reserved.
+// Use of this source code is governed by a BSD-style license that can be
+// found in the LICENSE file.
+
+#ifndef CONTENT_MEDIA_MEDIA_PROCESS_H_
+#define CONTENT_MEDIA_MEDIA_PROCESS_H_
+
+#include "content/child/child_process.h"
+
+namespace content {
+
+class MediaProcess : public ChildProcess {
+ public:
+  MediaProcess();
+  ~MediaProcess() override;
+
+ private:
+  DISALLOW_COPY_AND_ASSIGN(MediaProcess);
+};
+}
+
+#endif  // CONTENT_MEDIA_MEDIA_PROCESS_H_
